from atom import generate_entry

def generate_introspection(wfile, service):
    
    wfile.write("""<service xmlns="http://purl.org/atom/app#">\n""")
    
    for workspace in service.workspaces:
        generate_workspace(wfile, workspace)
    
    wfile.write("""</service>\n""")


def generate_workspace(wfile, workspace):
    
    wfile.write("""<workspace title="%s">\n""" % workspace.title)
    
    for collection_reference in workspace.collections:
        generate_collection_reference(wfile, collection_reference)
    
    wfile.write("""</workspace>\n""")


def generate_collection_reference(wfile, collection_reference):
    
    wfile.write("""<collection title="%s" href="%s">\n<member-type>%s</member-type>\n</collection>\n""" % (collection_reference.title, collection_reference.href, collection_reference.member_type))

