from atom import Entry


class Service:

    # workspaces[]
    
    def __init__(self):
        self.workspaces = []
        
        # extension elements
        self.children = []
        
    def add(self, child):
        self.children.append(child)
    
    
class Workspace:

    # title
    # collections[] - the first collection is the primary one (APP-07 7.2.2)

    def __init__(self, title=None):
        if title:
            self.title = title
            
        self.collections = []

        # extension elements
        self.children = []

    def add_collection(self, title, href, member_type):
        self.collections.append(CollectionReference(title, href, member_type))
        
    def add(self, child):
        self.children.append(child)

    
class CollectionReference:

    # title
    # href
    # member_type

    def __init__(self, title=None, href=None, member_type=None):
        # note that if arguments are not provided here, the attributes must
        # be set individually.

        self.title = title
        self.href = href
        self.member_type = member_type
        
        # extension elements
        self.children = []
        
    def add(self, child):
        self.children.append(child)
    
    

def updated_sort_key(member):
    return member.updated # @@@ need to normalize timezone
        


class Collection:

    # members[]
    
    def __init__(self):
        self.members = []
    
    def add_member(self, member):
        self.members.insert(0, member)
        self.members.sort(key=updated_sort_key, reverse=True)


class Member:
    pass