class Feed:

    def __init__(self):
        self.links = []
        self.authors = []
        self.contributors = []
        self.categories = []

        self.entries = []


class Entry:

    def __init__(self):
        self.links = []
        self.authors = []
        self.contributors = []
        self.categories = []

        # extension elements
        self.children = []
        
    def add(self, child):
        self.children.append(child)


class Category:

    def __init__(self):

        # extension elements
        self.children = []
        
    def add(self, child):
        self.children.append(child)


class Source:

    def __init__(self):
        self.links = []
        self.authors = []
        self.contributors = []
        self.categories = []

        # extension elements
        self.children = []
        
    def add(self, child):
        self.children.append(child)


class PlainText(object):
    
    def __init__(self, value=None):
        if value:
            self.value = value
    
    def get_type(self):
        if hasattr(self, "type_"):
            return self.type_
        else:
            return "text"
    
    def set_type(self, type):
        self.type_ = type

    type = property(get_type, set_type)


class XHTMLText:

    def __init__(self):
        self.children = []
        
    def add(self, child):
        self.children.append(child)
 

class Link(object):

    def __init__(self, rel=None, href=None):
        if rel:
            self.rel_ = rel
        if href:
            self.href = href

    def get_rel(self):
        if hasattr(self, "rel_"):
            return self.rel_
        else:
            return "alternate"
    
    def set_rel(self, rel):
        self.rel_ = rel

    rel = property(get_rel, set_rel)


class Generator:
    pass


class Person:

    def __init__(self, name=None, uri=None, email=None):

        if name:
            self.name = name
        if uri:
            self.uri = uri
        if email:
            self.email = email

        # extension elements
        self.children = []
        
    def add(self, child):
        self.children.append(child)


class Date:
    
    def __init__(self, value=None):
        if value:
            self.value = value        
    
    
class InlineTextContent:
    
    def __init__(self, content=None):
        if content:
            self.content = content
    
    
class InlineXHTMLContent:
    
    def __init__(self):
        self.children = []
        
    def add(self, child):
        self.children.append(child)
    
    
class InlineOtherContent:
    pass
    
    
class OutOfLineContent:

    def __init__(self, src=None):
        if src:
            self.src = src
