#!/usr/bin/env python

import sys
sys.path.append("../lib")

from store import AtomStore
import server

from atom.model import PlainText, Date, Person

atom_store = AtomStore("http://localhost:8000")

workspace = atom_store.create_workspace("Colleciton Paging Test Workspace")

collection1 = atom_store.create_collection("Collection 1", "/collection/1", "media")

collection2 = atom_store.create_collection("Collection 2", "/collection/2", "media")

collection3 = atom_store.create_collection("Collection 3", "/collection/3", "media")

workspace.add_collection(collection1)
workspace.add_collection(collection2)
workspace.add_collection(collection3)

def add_entries(collection, count):
    for i in range(count):
    
        path = "/%d" % i
    
        member = atom_store.create_media_member(path, "text/plain")
        member.raw_content = "Hello from %d" % i
    
        member.title = PlainText("Sample %d" % i)
        member.updated = Date("20%02d-%02d-13T00:00:00Z" % (i / 10, i % 10))
        member.authors = [Person(name="Sam Pell")]
    
        collection.add_member(member)


add_entries(collection1, 5)
add_entries(collection2, 10)
add_entries(collection3, 95)

server.atom_store = atom_store # @@@ hack for now
server.AtomServer().serve_forever()