#!/usr/bin/env python

import sys
sys.path.append("../lib")

from atom import parse_atom, AtomException

print "example1"

ex1 = file("data/example1.atom").read()


feed = parse_atom(ex1)
assert feed.title.value == "Example Feed"
assert len(feed.links) == 1
assert feed.links[0].href == "http://example.org/"
assert feed.updated.value == "2003-12-13T18:30:02Z"
assert feed.authors[0].name == "John Doe"
assert feed.id == "urn:uuid:60a76c80-d399-11d9-b93C-0003939e0af6"
assert len(feed.entries) == 1
entry = feed.entries[0]
assert entry.title.value == "Atom-Powered Robots Run Amok"
assert len(entry.links) == 1
assert entry.links[0].href == "http://example.org/2003/12/13/atom03"
assert entry.id == "urn:uuid:1225c695-cfb8-4ebb-aaaa-80da344efa6a"
assert entry.updated.value == "2003-12-13T18:30:02Z"
assert entry.summary.value == "Some text."

ex2 = file("data/example2.atom").read()

print "example2"

feed = parse_atom(ex2)
assert feed.title.value == "dive into mark"
assert feed.title.type == "text"
assert feed.subtitle.type == "html"
assert feed.subtitle.value == """A <em>lot</em> of effort
       went into making this effortless"""
assert feed.updated.value == "2005-07-31T12:29:29Z"
assert feed.id == "tag:example.org,2003:3"
assert len(feed.links) == 2
assert feed.links[0].href == "http://example.org/"
assert feed.links[0].type == "text/html"
assert feed.links[0].rel == "alternate"
assert feed.links[0].hreflang == "en"
assert feed.links[1].href == "http://example.org/feed.atom"
assert feed.links[1].type == "application/atom+xml"
assert feed.links[1].rel == "self"
assert feed.rights == "Copyright (c) 2003, Mark Pilgrim"
assert feed.generator.uri == "http://www.example.com/"
assert feed.generator.version == "1.0"
assert feed.generator.value == """Example Toolkit"""
assert len(feed.entries) == 1
entry = feed.entries[0]
assert entry.title.value == "Atom draft-07 snapshot"
assert len(entry.links) == 2
assert entry.links[0].rel == "alternate"
assert entry.links[0].type == "text/html"
assert entry.links[0].href == "http://example.org/2005/04/02/atom"
assert entry.links[1].rel == "enclosure"
assert entry.links[1].type == "audio/mpeg"
assert entry.links[1].length == "1337"
assert entry.links[1].href == "http://example.org/audio/ph34r_my_podcast.mp3"
assert entry.id == "tag:example.org,2003:3.2397"
assert entry.updated.value == "2005-07-31T12:29:29Z"
assert entry.published.value == "2003-12-13T08:29:29-04:00"
assert entry.authors[0].name =="Mark Pilgrim"
assert entry.authors[0].uri =="http://example.org/"
assert entry.authors[0].email =="f8dy@example.com"
assert len(entry.contributors) == 2
assert entry.contributors[0].name == "Sam Ruby"
assert entry.contributors[1].name == "Joe Gregorio"
assert entry.content.type == "xhtml"
assert entry.content.children[0].name == "http://www.w3.org/1999/xhtml^div"
assert entry.content.children[0].attributes == {}
assert entry.content.children[0].children[2].name == "http://www.w3.org/1999/xhtml^p"
assert entry.content.children[0].children[2].children[0].name == "http://www.w3.org/1999/xhtml^i"
assert entry.content.children[0].children[2].children[0].children[0].chardata == "[Update: The Atom draft is finished.]"


print "3.1 test a"

feed = parse_atom(file("data/test31a.atom").read())
assert feed.title.type == "text"
assert feed.title.value == "Example Feed"

print "3.1 test b"

success = False

try:
    feed = parse_atom(file("data/test31b.atom").read())
except AtomException:
    success = True
    
assert success

print "3.1 test c"

success = False

try:
    feed = parse_atom(file("data/test31c.atom").read())
except AtomException:
    success = True
    
assert success

print "3.1 test d"

success = False

try:
    feed = parse_atom(file("data/test31d.atom").read())
except AtomException:
    success = True
    
assert success

print "3.1 test e"

success = False

try:
    feed = parse_atom(file("data/test31e.atom").read())
except AtomException:
    success = True
    
assert success

print "3.1 test f"

success = False

try:
    feed = parse_atom(file("data/test31f.atom").read())
except AtomException:
    success = True
    
assert success

print "3.1 test g"

feed = parse_atom(file("data/test31g.atom").read())

assert feed.title.children[0].name == "http://www.w3.org/1999/xhtml^div"

print "3.1 test i"

feed = parse_atom(file("data/test31i.atom").read())

assert feed.entries[0].summary.children[0].name == "http://www.w3.org/1999/xhtml^div"

print "no children"
success = False

try:
    feed = parse_atom(file("data/nochildren.atom").read())
except AtomException:
    success = True
    
assert success


print "link"

link = file("data/link.atom").read()
feed = parse_atom(link)

assert feed.entries[0].links[0].rel == "alternate"

print "summary"

summary = file("data/summary.atom").read()
feed = parse_atom(summary)

assert feed.entries[0].summary.type == "text"
assert feed.entries[1].summary.type == "text"
assert feed.entries[2].summary.type == "html"
assert feed.entries[3].summary.type == "xhtml"

print "content1"

content1 = file("data/content1.atom").read()
feed = parse_atom(content1)


print "entry"

e = file("data/entry1.atom").read()
entry = parse_atom(e)


print "category"

cat = file("data/category.atom").read()
feed = parse_atom(cat)


print "non-Atom"

success = False

try:
    parse_atom("<foo/>")
except AtomException:
    success = True
    
assert success

print "source"

feed = parse_atom(file("data/source.atom").read())
