#!/usr/bin/env python

from cStringIO import StringIO

import sys
sys.path.append("../lib")

from app import parse_introspection, generate_introspection, AtomProtocolException

empty_service = """<service xmlns="http://purl.org/atom/app#"/>"""

try:
    service = parse_introspection(empty_service)
    assert False
except AtomProtocolException:
    pass

f = file("data/07-introspection.xml").read()

service = parse_introspection(f)

assert len(service.workspaces) == 2
assert service.workspaces[0].title == "Main Site"
assert service.workspaces[1].title == "Side Bar Blog"
assert len(service.workspaces[0].collections) == 2
assert len(service.workspaces[1].collections) == 1
assert service.workspaces[0].collections[0].title == "My Blog Entries"
assert service.workspaces[0].collections[0].href == "http://example.org/reilly/main"
assert service.workspaces[0].collections[0].member_type == "entry"
assert service.workspaces[0].collections[1].title == "Pictures"
assert service.workspaces[0].collections[1].href == "http://example.org/reilly/pic"
assert service.workspaces[0].collections[1].member_type == "media"
assert service.workspaces[1].collections[0].title == "Remaindered Links"
assert service.workspaces[1].collections[0].href == "http://example.org/reilly/list"
assert service.workspaces[1].collections[0].member_type == "entry"

out = StringIO()
generate_introspection(out, service)

def compare(a, b):
    print len(a), len(b)
    for i in range(min(len(a), len(b))):
        print ord(a[i]), ord(b[i])
        if a[i] != b[i]:
            break

assert out.getvalue() == file("data/07-introspection-out.xml").read()
