#!/usr/bin/env python

import sys
sys.path.append("../lib")

import atom
from cStringIO import StringIO

inp = file("data/example1.atom").read()
feed = atom.parse_atom(inp)
out = StringIO()
atom.generate_atom(out, feed)

assert out.getvalue() == """<?xml version="1.0" encoding="utf-8"?>
<feed xmlns="http://www.w3.org/2005/Atom">
<title>Example Feed</title>
<id>urn:uuid:60a76c80-d399-11d9-b93C-0003939e0af6</id>
<updated>2003-12-13T18:30:02Z</updated>
<link href="http://example.org/"/>
<author>
<name>John Doe</name>
</author>
<entry>
<title>Atom-Powered Robots Run Amok</title>
<id>urn:uuid:1225c695-cfb8-4ebb-aaaa-80da344efa6a</id>
<updated>2003-12-13T18:30:02Z</updated>
<link href="http://example.org/2003/12/13/atom03"/>
<summary>Some text.</summary>
</entry>
</feed>
"""

# make sure we can re-parse
atom.parse_atom(out.getvalue())

inp = file("data/example2.atom").read()
feed = atom.parse_atom(inp)
out = StringIO()
atom.generate_atom(out, feed)

assert out.getvalue() == """<?xml version="1.0" encoding="utf-8"?>
<feed xmlns="http://www.w3.org/2005/Atom">
<title type="text">dive into mark</title>
<subtitle type="html">A &lt;em>lot&lt;/em> of effort
       went into making this effortless</subtitle>
<id>tag:example.org,2003:3</id>
<updated>2005-07-31T12:29:29Z</updated>
<link href="http://example.org/" rel="alternate" type="text/html" hreflang="en"/>
<link href="http://example.org/feed.atom" rel="self" type="application/atom+xml"/>
<rights>Copyright (c) 2003, Mark Pilgrim</rights>
<generator uri="http://www.example.com/" version="1.0">Example Toolkit</generator>
<entry>
<title>Atom draft-07 snapshot</title>
<id>tag:example.org,2003:3.2397</id>
<updated>2005-07-31T12:29:29Z</updated>
<published>2003-12-13T08:29:29-04:00</published>
<link href="http://example.org/2005/04/02/atom" rel="alternate" type="text/html"/>
<link href="http://example.org/audio/ph34r_my_podcast.mp3" rel="enclosure" type="audio/mpeg" length="1337"/>
<author>
<name>Mark Pilgrim</name>
<uri>http://example.org/</uri>
<email>f8dy@example.com</email>
</author>
<contributor>
<name>Sam Ruby</name>
</contributor>
<contributor>
<name>Joe Gregorio</name>
</contributor>
<content type="xhtml">
<xhtml:div xmlns:xhtml="http://www.w3.org/1999/xhtml">
           <xhtml:p><xhtml:i>[Update: The Atom draft is finished.]</xhtml:i></xhtml:p>
         </xhtml:div></content>
</entry>
</feed>
"""

# make sure we can re-parse
atom.parse_atom(out.getvalue())
